﻿using System.Text.Json;

namespace Discord
{
    static internal class JSON
    {
        public static JsonSerializerOptions SerializeOptions = new()
        {
            WriteIndented = true,
            PropertyNamingPolicy = JsonNamingPolicy.SnakeCaseLower
        };

        public static JsonSerializerOptions DeserializeOptions = new()
        {
            PropertyNamingPolicy = JsonNamingPolicy.SnakeCaseLower
        };

        public static string Serialize<T>(T obj)
        {
            return JsonSerializer.Serialize<T>(obj, SerializeOptions);
        }

        public static T? Deserialize<T>(string json)
        {
            return JsonSerializer.Deserialize<T>(json, DeserializeOptions);
        }
    }
}
