﻿namespace Discord.Managers
{
    public class MessageManager : Manager<string, Message>
    {
        public Channel Channel;

        public MessageManager(Client client, Channel channel) : base(client) {
            Channel = channel;
        }

        public async Task<Message?> Fetch(string id)
        {
            Message? msg = await Client.Rest.Get<Message>(REST.Routes.Message(Channel.Id, id));
            if(msg != null)
            {
                msg.Client = Client;
                Cache[id] = msg;
            }
            return msg;
        }

        public async Task<Message?> Get(string id)
        {
            if (Cache.ContainsKey(id)) return Cache[id];
            return await Fetch(id);
        }
    }
}
