﻿namespace Discord.Managers
{
    public class UserManager : Manager<string, User>
    {
        public UserManager(Client client) : base(client) { }

        public async Task<User?> Fetch(string id)
        {
            User? user = await Client.Rest.Get<User>(REST.Routes.User(id));
            if(user != null)
            {
                user.Client = Client;
                Cache[id] = user;
            }
            return user;
        }

        public async Task<User?> Get(string id)
        {
            if (Cache.ContainsKey(id)) return Cache[id];
            return await Fetch(id);
        }
    }
}
