﻿using Discord.Managers;
using Discord.REST.Payloads;

namespace Discord
{
    public class Channel : Base
    {
        public required string Id { get; set; }
        public required int Type { get; set; }
        public string? Name { get; set; }
        public MessageManager? Messages { get; set; }

        public async Task<Message?> Send(string content)
        {
            return await Client!.Rest.Post<Message, MessagePayload>(REST.Routes.Messages(Id), 
                new MessagePayload() { 
                    Content = content
                });
        }

        public override string ToString()
        {
            return JSON.Serialize(this);
        }
    }
}
